# E0030: octal literal may not have exponent

Decimal number literals can contain exponents. Octal number literals, which
start with an extra `0` digit, cannot contain exponents:

```javascript
const googol = 01e+100;
```

To fix this error, make the number literal a decimal number literal by removing
the extra leading `0`:

```javascript
const googol = 1e+100;
```

Introduced in quick-lint-js version 0.2.0.
