# E0031: octal literal may not have decimal

Decimal number literals can contain a decimal (fraction). Octal number literals,
which start with an extra `0` digit, cannot contain a decimal:

```javascript
const PI = 03.14;
```

To fix this error, make the number literal a decimal number literal by removing
the extra leading `0`:

```javascript
const PI = 3.14;
```

Introduced in quick-lint-js version 0.2.0.
