# E0038: unclosed identifier escape sequence

Identifiers can contain Unicode escape sequences starting with `\u`. It is a
syntax error to write `\u{` followed by hexadecimal digits without a closing
`}`:

```javascript
let guitar\u{3604 = "\u{D83C}\u{";
```

To fix this error, write `}` to close the escape sequence.

```javascript
let guitar\u{3604} = "\u{D83C}\u{DFB8}";
```

Introduced in quick-lint-js version 0.2.0.
