# E0049: binary number literal has no digits

Decimal number literals start with `0b` and require at least one digit. It is an
error to write `0b` with no following digits:

```javascript
let mask = 0b
```

To fix this error, write digits after `0b`:

```javascript
let mask = 0b1000;
```

Alternatively, remove `b` to create a `0` number literal.

Introduced in quick-lint-js version 0.2.0.
