# E0050: hex number literal has no digits

Hexadecimal (hex) number literals start with `0x` and require at least one
digit. It is an error to write `0x` with no following digits:

```javascript
let mask = 0x
```

To fix this error, write digits after `0x`:

```javascript
let mask = 0xff00;
```

Alternatively, remove `x` to create a `0` number literal.

Introduced in quick-lint-js version 0.2.0.
