# E0061: missing name in function statement

If a statement begins with the `function` keyword, the declared function must
have a name. It is an error to start a statement with `function` but not give a
name to the function:

```javascript
function (number) {
  return number % 2 === 0;
}
```

To fix this error, write the name of the function after the `function` keyword:

```javascript
function isEven(number) {
  return number % 2 === 0;
}
```

Introduced in quick-lint-js version 0.2.0.
