# E0067: exporting requires 'default'

It is a syntax error to export an expression without using the `default`
keyword:

```javascript
function loadConfig() {}

export loadConfig();
```

To fix this error, add the `default` keyword to export the result of the
expression as the module's default export:

```javascript
function loadConfig() {}

export default loadConfig();
```

Introduced in quick-lint-js version 0.2.0.
