# E0087: while loop needs parentheses around condition

`while` loops have a condition after the `while` keyword. It is a syntax error
to write a condition without `(` and `)`:

```javascript
let name = '';
while name === '' {
  name = prompt('What is your name?');
}
```

To fix this error, write `(` before the condition and `)` after the condition:

```javascript
let name = '';
while (name === '') {
  name = prompt('What is your name?');
}
```

Introduced in quick-lint-js version 0.2.0.
