# E0095: Unicode byte order mark (BOM) cannot appear before #! at beginning of script

A script cannot have Unicode byte order mark (BOM) before `#!`

```javascript
﻿#!/usr/bin/env node
let x = 3;
console.log(x);
```

To fix this error, remove the Unicode BOM before `#!`

```javascript
#!/usr/bin/env node
let x = 3;
console.log(x);
```

Introduced in quick-lint-js version 0.3.0.
