# E0099: missing semicolon between init and condition parts of for loop

C-style `for` loops require two semicolons: one `;` between the init and the
condition, and one `;` between the condition and the update expression. It is a
syntax error to omit the `;` between the init and the condition:

```javascript
let i;
for (i = 0 i < 100; ++i) {
  console.log(i % 15 ? i : "FizzBuzz");
}
```

To fix this error, insert a semicolon (`;`) before the condition:

```javascript
let i;
for (i = 0; i < 100; ++i) {
  console.log(i % 15 ? i : "FizzBuzz");
}
```

Introduced in quick-lint-js version 0.2.0.
