# E0126: expected 'as' between '\*' and variable

You can import all of a module's exports using `import *`. It is a syntax error
to omit the `as` keyword between the `*` and the new object's name:

```javascript
import * d3 from 'd3';
```

To fix this error, write `as` after `*`:

```javascript
import * as d3 from 'd3';
```

Introduced in quick-lint-js version 0.2.0.
