# E0128: expected 'from' before module specifier

`import` statements load things from other files. It is a syntax error to omit
the `from` keyword before the module name:

```javascript
import React, {createElement} 'react';
```

To fix this error, write the `from` keyword before the module name:

```javascript
import React, {createElement} from 'react';
```

Introduced in quick-lint-js version 0.2.0.
