# E0129: expected 'from "name_of_module.mjs"'

`import` statements load things from other files. It is a syntax error to omit
the name of the module being imported:

```javascript
import React, {createElement};
```

To fix this error, write the `from` keyword followed by the module name:

```javascript
import React, {createElement} from 'react';
```

Introduced in quick-lint-js version 0.2.0.
