# E0157: missing end of array; expected ']'

An array literal requires a list of items surrounded by `[` and `]`. It is a
syntax error to start an array literal with `[` but omit the final `]`:

```javascript
let friends = ["Alice";
```

To fix this error, write `]` at the end of the array literal:

```javascript
let friends = ["Alice"];
```

Introduced in quick-lint-js version 0.3.0.
