# E0180: stray comma in function parameter

```config-for-examples
{
  "globals": {
    "data": true
  }
}
```

A function parameter can be a variable name, an array destructuring, or an
object destructuring. It is a syntax error for a parameter name to be in
parentheses with a comma:

```javascript-ignoring-extra-errors
let firsts = data.map([(x,)] => x);
```

To fix this error, remove the comma:

```javascript
let firsts = data.map([x] => x);
```

Introduced in quick-lint-js version 1.0.0.
