# E0215: unclosed interface; expected '}' by end of file

Every `{` introducing an interface block must have a matching `}` ending an
interface block. It is a syntax error to omit the `}`:

```typescript
export interface API {
  fetch(uri, params);
```

To fix this error, write a matching `}`:

```typescript
export interface API {
  fetch(uri, params);
}
```

Introduced in quick-lint-js version 2.6.0.
