# E0270: TypeScript type imports are not allowed in JavaScript

TypeScript supports importing types using `import type`. It is a syntax error to
write `import type` in JavaScript code:

```javascript
import React, {type FC} from "react";
```

To fix this error, delete the imported type:

```javascript
import React from "react";
```

Introduced in quick-lint-js version 2.8.0.
