# E0293: missing semicolon after abstract method

TypeScript abstract methods in classes do not have bodies. Therefore, they
must end with either a semicolon (`;`) or a newline. It is a syntax error to
omit the semicolon and write something on the same line after the abstract
method:

```typescript
abstract class Container {
  abstract getItem(key: string): number | string void;
}
```

To fix this error, write a correct type for the method:

```typescript
abstract class Container {
  abstract getItem(key: string): number | string | void;
}
```

Introduced in quick-lint-js version 2.10.0.
