# E0325: cannot delete variables in TypeScript

In JavaScript, it is possible to use `delete` on a variable. In TypeScript,
deleting a variable is an error:

```typescript
let x = 3;
delete x;
console.log(x);
```

To fix this error, remove the `delete` statement:

```typescript
let x = 3;
console.log(x);
```

See also: E0086

Introduced in quick-lint-js version 2.10.0.
