# E0327: 'function async' is not allowed; write 'async function' instead

Functions can be marked with the `async` keyword. It is a syntax error to write
the `async keyword after the `function` keyword:

```javascript
function async f() {
  return 0;
}
```

To fix this error, replace `function async` with `async function`:

```javascript
async function f() {
  return 0;
}
```
