# E0374: unexpected whitespace between '!' and '=='

`x! == y` is a typo for a strict inequality, as in `x !== y`:

```javascript
let x = 17;
let y = 38;
if (x! == y) {
    alert('Not equal!');
}
```

To fix the warning, replace `! ==` with ` !==`:

```javascript
let x = 17;
let y = 38;
if (x !== y) {
  alert("Not equal!");
}
```

See also: E0373
