# E0376: JSX prop is missing an expression

Every attribute in JSX with a prop requires an expression:

```javascript-jsx
function Header({columns}) {
  return (<>
    <div numColumns={}>Name</div>
  </>);
}
```

To fix the mistake, add a valid expression to the prop:

```javascript-jsx
function Header({columns}) {
  return (<>
    <div numColumns={columns}>Name</div>
  </>);
}
```