# E0381: Typescript does not allow keywords to contain escape sequence

The following code is legal in JavaScript but is illegal in TypeScript

```typescript
class C {
  \u{63}onstructor() {}  // equivalent to: constructor() {}
}
```

To fix this error, remove the escape sequence in the keyword.


```typescript
class C {
  constructor() {}  // equivalent to: constructor() {}
}
```
