# E0712: missing ',' between array elements

This error occurs when there is a missing comma (',') between elements in an array
declaration or initialization. In JavaScript, commas are used to separate individual
elements within an array, and the absence of a comma will lead to a syntax error.

```javascript
let myArray = [1 2 3];
```

To fix this error, you need to add a comma between each element within the array declaration or initialization

```javascript
let myArray = [1, 2, 3];
```
